package cn.com.tenlion.systembase.service.keyplace;

import cn.com.tenlion.systembase.pojo.bos.keyplace.KeyPlaceBO;
import cn.com.tenlion.systembase.pojo.dtos.keyplace.KeyPlaceDTO;
import cn.com.tenlion.systembase.pojo.pos.keyplace.KeyPlacePO;
import cn.com.tenlion.systembase.pojo.vos.keyplace.KeyPlaceVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IKeyPlaceService
 * @Description: 重点场所
 * @Author: CodeFactory
 * @Date: 2021-11-16 11:25:17
 * @Version: 3.0
 **/
public interface IKeyPlaceService {

    /**
     * 新增重点场所
     *
     * @param keyPlaceVO
     * @return
     */
    void save(KeyPlaceVO keyPlaceVO);

    /**
     * 新增重点场所
     *
     * @param token
     * @param keyPlaceVO
     * @return
     */
    void save(String token, KeyPlaceVO keyPlaceVO);

    /**
     * 新增重点场所
     *
     * @param keyPlaceVO
     * @return keyPlaceId
     */
    String saveReturnId(KeyPlaceVO keyPlaceVO);

    /**
     * 新增重点场所
     *
     * @param token
     * @param keyPlaceVO
     * @return keyPlaceId
     */
    String saveReturnId(String token, KeyPlaceVO keyPlaceVO);

    /**
     * 删除重点场所
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids, String idsStr);


    /**
     * 删除重点场所
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids, String idsStr);

    /**
     * 删除重点场所（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改重点场所
     *
     * @param keyPlaceId
     * @param keyPlaceVO
     * @return
     */
    void update(String keyPlaceId, KeyPlaceVO keyPlaceVO);

    /**
     * 修改重点场所
     *
     * @param token
     * @param keyPlaceId
     * @param keyPlaceVO
     * @return
     */
    void update(String token, String keyPlaceId, KeyPlaceVO keyPlaceVO);

    /**
     * 重点场所详情
     *
     * @param params 参数Map
     * @return
     */
    KeyPlaceDTO get(Map<String, Object> params);

    /**
     * 重点场所详情
     *
     * @param keyPlaceId
     * @return
     */
    KeyPlaceDTO get(String keyPlaceId);

    /**
     * 重点场所详情
     *
     * @param params 参数Map
     * @return
     */
    KeyPlaceBO getBO(Map<String, Object> params);

    /**
     * 重点场所详情
     *
     * @param keyPlaceId
     * @return
     */
    KeyPlaceBO getBO(String keyPlaceId);

    /**
     * 重点场所详情
     *
     * @param params 参数Map
     * @return
     */
    KeyPlacePO getPO(Map<String, Object> params);

    /**
     * 重点场所详情
     *
     * @param keyPlaceId
     * @return
     */
    KeyPlacePO getPO(String keyPlaceId);

    /**
     * 重点场所列表
     *
     * @param params
     * @return
     */
    List<KeyPlaceDTO> list(Map<String, Object> params);

    /**
     * 重点场所列表
     *
     * @param params
     * @return
     */
    List<KeyPlaceBO> listBO(Map<String, Object> params);

    /**
     * 重点场所列表
     *
     * @param params
     * @return
     */
    List<KeyPlacePO> listPO(Map<String, Object> params);

    /**
     * 重点场所分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<KeyPlaceDTO>> listPage(ListPage page);

    /**
     * 重点场所统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    void saveKafka(String uid, KeyPlaceVO keyPlaceVO);

    void updateKafka(String uid, KeyPlaceVO keyPlaceVO);

    void deleteKafka(String uid);

}